\documentclass[10pt,a4paper]{refart}

\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[english]{isodate}
\usepackage[parfill]{parskip}

\usepackage{float}
\usepackage{graphicx}
\usepackage{listings}
\usepackage{color}
\usepackage{textcomp,tipa}

\usepackage{amssymb}
\usepackage[normalem]{ulem}
\usepackage{hyperref}
\usepackage{feynmp}
\usepackage{etoolbox}
\usepackage{ifpdf}
\ifpdf
\DeclareGraphicsRule{*}{mps}{*}{}
\fi
\usepackage{multirow}
\usepackage{subfigure}
\usepackage{pdflscape}
%% \usepackage{subfig}
\usepackage{textpos}
\usepackage{pdfpages}
\usepackage{tikz}

\usepackage{pgfplots}
\usetikzlibrary{positioning}
% ,positioning-plus,node-families}
% \usetikzlibrary{geometric,fit}
\usetikzlibrary{fit}
\usetikzlibrary{backgrounds}
\usetikzlibrary{calc}
\usetikzlibrary{shapes,shadows,arrows}
\usetikzlibrary{mindmap}
\usetikzlibrary{decorations.text}
\pgfplotsset{compat=1.7}

\title{GEM Firmware RPM Functional Specifications}
\author{GEM Commissioining, Operations, and Online Software Group}
\date{\today}

\begin{document}

\maketitle

\section{Outline}
\label{sec:outline}
This document aims to provide a concise set of functional requirements for RPM packages of GEM firmware.
The functional needs are broadly grouped into the following main areas:
\begin{itemize}
\item Package description
\item Package dependencies
\item Use cases
\end{itemize}

Section~\ref{sec:details} will describe in details the package needs, and Sec.~\ref{sec:requirements} will describe the requirements for interacting with the package

Section~\ref{sec:usecases} summarizes use cases.

Section~\ref{sec:status} summarizes the state of the art.

\input{gem-spec-common-terminology}

\newpage

\section{Details}
\label{sec:details}

\subsection{Tables}
\label{subsec:details:tables}
\subsubsection{Component tables}
\begin{table}[!h]
  \begin{tabular}[!h]{r|l}
    Component & Description\\
    \hline
    \hline
    OptoHybrid & \texttt{<PART>} table \\
    AMC        & not tracked in the DB \\
    \hline
  \end{tabular}
\end{table}

\subsubsection{Other tables}
\begin{table}[!h]
  \begin{tabular}[!h]{r|l}
    Table & Description\\
    \hline
    \hline
    Chamber     & Links together all components into a single GEM chamber\\
    QC7 results & Summary table for the information related to a single QC7 test\\
    \hline
  \end{tabular}
\end{table}

\subsubsection{\texttt{OptoHybrid}}

\subsubsection{\texttt{AMC}}

\newpage

\section{Requirements}
\label{sec:requirements}

This section outlines the general requirements needed for the RPM package.

\subsection{General}
\label{subsec:requirements:general}
\begin{itemize}
\item Multiple versions of the firmware may be installed on a machine at a given time
\item Only one version must be active at a given time
\item Different types of one version may be active at a given time (GE2/1, GE1/1)
\item Tools must be provided to allow seamless switching between versions, including 
  \begin{itemize}
  \item Changing the active version on the PC (and back-end card)
  \item Sending a new version to back-end cards
  \end{itemize}
\end{itemize}

These requirements naturally lead to a set of packages described hereafter.
\begin{itemize}
\item One \texttt{gem-firmware-tools} package, which provides the scripts and tooling that are common across all versions and flavours
\item One \texttt{gem-firmware-amc(-<type>)-vXYZ} package, which contains \texttt{.bit} and \texttt{.mcs} firmware images, \texttt{.xml} address table files, and \texttt{.pdf} documentation files for the \texttt{GEM\_AMC} firmware package
  \begin{itemize}
  \item Here \texttt{<type>} is optional, and only necessary if having a separate package for, e.g., GLIB vs.~CTP7 vs.~APx vs.~PCIe board is desired, but this should not be required and would be viewed as a design flaw.
  \end{itemize}
\item One \texttt{gem-firmware-optohybrid-vXYZ} package, which contains \texttt{.bit} and \texttt{.mcs} firmware images, \texttt{.xml} address table files, and \texttt{.pdf} documentation files for the \texttt{OptoHybrid} firmware package.
\end{itemize}

\subsection{Contents}
\label{subsec:requirements:contents}
Extraction is most important for configuration and visualization.

\subsubsection{\texttt{gem-firmware-tools}}
This package provides a TUI/GUI/script for activating a specific version of the firmware.
It should find the installed versions and list them.
When the user has selected the desired active version combination (both AMC and OptoHybrid) the script will update symlinks in \texttt{GEM\_ADDRESS\_TABLE\_PATH} to point to these files.

\subsubsection{\texttt{gem-firmware-amc(-<type>)-vXYZ}}
This package provides all the artifacts of a build of the \texttt{GEM\_AMC} firmware package.
The package name includes the major,minor,and build version numbers, allowing multiple versions to be installed simultaneously

\begin{itemize}
\item \texttt{gem\_amc\_top\_vX\_Y\_Z.bit}
\item \texttt{gem\_amc\_top\_vX\_Y\_Z.xml}
\item \texttt{uhal\_gem\_amc\_vX\_Y\_Z\_ctp7\_amc.xml}
\item \texttt{uhal\_gem\_amc\_vX\_Y\_Z\_glib\_amc.xml}
\item \texttt{uhal\_gem\_amc\_vX\_Y\_Z\_apx\_amc.xml}
\item \texttt{uhal\_gem\_amc\_vX\_Y\_Z\_ctp7\_linkXX.xml}
\item \texttt{uhal\_gem\_amc\_vX\_Y\_Z\_glib\_linkXX.xml}
\item \texttt{uhal\_gem\_amc\_vX\_Y\_Z\_apx\_linkXX.xml}
\end{itemize}

\subsubsection{\texttt{gem-firmware-optohybrid-vXYZ}}

\subsection{Installation}
\label{subsec:requirements:installation}


\newpage

\section{Use cases}
\label{sec:usecases}

\newpage

\section{Status}
\label{sec:status}

\end{document}
